Grant agent access to wallet
curl --request POST \
--url https://api.natural.com/wallets/{walletId}/agents \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"agentId": "agt_019cd1798d637a4da75dce386343931d"
}
}
}
'import requests
url = "https://api.natural.com/wallets/{walletId}/agents"
payload = { "data": { "attributes": { "agentId": "agt_019cd1798d637a4da75dce386343931d" } } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({data: {attributes: {agentId: 'agt_019cd1798d637a4da75dce386343931d'}}})
};
fetch('https://api.natural.com/wallets/{walletId}/agents', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/wallets/{walletId}/agents",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'agentId' => 'agt_019cd1798d637a4da75dce386343931d'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/wallets/{walletId}/agents"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/wallets/{walletId}/agents")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/wallets/{walletId}/agents")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"type": "agent",
"id": "agt_019cd1798d637a4da75dce386343931d",
"attributes": {
"name": "Procurement Agent",
"description": "Buys supplies",
"tags": {
"department": "procurement"
},
"handle": "@acme-procurementagent",
"status": "ACTIVE",
"limits": {
"perTransaction": 100000
},
"createdAt": "2026-01-04T15:30:00.000Z",
"createdBy": "usr_019cd1798d657de5b5fed4198cb9fac0",
"lastActiveAt": "2026-01-05T09:12:00.000Z"
},
"relationships": {
"party": {
"data": {
"type": "party",
"id": "pty_019cd1798d617f65a79cb965dda9eac3"
}
}
},
"meta": {
"walletAccess": {
"accessType": "owned",
"isDefault": true,
"attachedAt": "2026-01-05T10:00:00.000Z"
}
}
}
}Wallet Access
Grant agent access to wallet
Grant an owned or customer-connected agent access to a standard wallet. The first wallet becomes its default, and a connected agent also needs delegations.update. Returns the Wallet Access object.
POST
/
wallets
/
{walletId}
/
agents
Grant agent access to wallet
curl --request POST \
--url https://api.natural.com/wallets/{walletId}/agents \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"agentId": "agt_019cd1798d637a4da75dce386343931d"
}
}
}
'import requests
url = "https://api.natural.com/wallets/{walletId}/agents"
payload = { "data": { "attributes": { "agentId": "agt_019cd1798d637a4da75dce386343931d" } } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({data: {attributes: {agentId: 'agt_019cd1798d637a4da75dce386343931d'}}})
};
fetch('https://api.natural.com/wallets/{walletId}/agents', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/wallets/{walletId}/agents",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'agentId' => 'agt_019cd1798d637a4da75dce386343931d'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/wallets/{walletId}/agents"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/wallets/{walletId}/agents")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/wallets/{walletId}/agents")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"agentId\": \"agt_019cd1798d637a4da75dce386343931d\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"type": "agent",
"id": "agt_019cd1798d637a4da75dce386343931d",
"attributes": {
"name": "Procurement Agent",
"description": "Buys supplies",
"tags": {
"department": "procurement"
},
"handle": "@acme-procurementagent",
"status": "ACTIVE",
"limits": {
"perTransaction": 100000
},
"createdAt": "2026-01-04T15:30:00.000Z",
"createdBy": "usr_019cd1798d657de5b5fed4198cb9fac0",
"lastActiveAt": "2026-01-05T09:12:00.000Z"
},
"relationships": {
"party": {
"data": {
"type": "party",
"id": "pty_019cd1798d617f65a79cb965dda9eac3"
}
}
},
"meta": {
"walletAccess": {
"accessType": "owned",
"isDefault": true,
"attachedAt": "2026-01-05T10:00:00.000Z"
}
}
}
}Authorizations
Headers
Was this page helpful?